"use strict";
exports.__esModule = true;
var Container = (function () {
    function Container(type, element) {
        this.type = type;
        this.element = element;
    }
    return Container;
}());
var ContainerStack = (function () {
    function ContainerStack() {
        this.internalStack = [];
    }
    ContainerStack.prototype.pushContainer = function (type, element) {
        this.internalStack.push(new Container(type, element));
    };
    ContainerStack.prototype.removeContainer = function (type) {
        var length = this.internalStack.length;
        if (length > 0) {
            var peekedContainer = this.internalStack[length - 1];
            if (peekedContainer.type === type)
                this.internalStack.pop();
        }
    };
    ContainerStack.prototype.peekCurrentContainer = function () {
        var length = this.internalStack.length;
        if (length > 0)
            return this.internalStack[length - 1].element;
    };
    return ContainerStack;
}());
exports["default"] = ContainerStack;
