/// <reference types="react" />
import { Node } from 'commonmark';
import { ReactElement } from 'react';
import RenderOptions from '../RenderOptions';
export default abstract class CommonMarkRenderer {
    protected node: Node;
    protected options: RenderOptions;
    constructor(node: Node, options: RenderOptions | undefined);
    renderNode(key: string): ReactElement<any> | string | null;
    protected getDefaultProps(key: string): object;
    protected abstract renderNodeWithProps(props: object): ReactElement<any> | string | null;
}
