"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
exports.__esModule = true;
var react_1 = require("react");
var CommonMarkRenderer_1 = require("./CommonMarkRenderer");
var ImageRenderer = (function (_super) {
    __extends(ImageRenderer, _super);
    function ImageRenderer(node, options) {
        return _super.call(this, node, options) || this;
    }
    ImageRenderer.prototype.getDefaultProps = function (key) {
        var defaultProps = _super.prototype.getDefaultProps.call(this, key);
        var title = this.node.title;
        if (title)
            defaultProps.title = title;
        defaultProps.alt = this.findAltText();
        defaultProps.src = this.node.destination;
        return defaultProps;
    };
    ImageRenderer.prototype.renderNodeWithProps = function (props) {
        return react_1.createElement('img', props);
    };
    ImageRenderer.prototype.clearAltTextNode = function (node) {
        // dirty side effect, text node has to be cleared because img react elements can't have childrem
        node.literal = null;
    };
    ImageRenderer.prototype.findAltText = function () {
        var textNode = this.node.firstChild;
        if (textNode) {
            var altText = textNode.literal;
            this.clearAltTextNode(textNode);
            return altText || undefined;
        }
    };
    return ImageRenderer;
}(CommonMarkRenderer_1["default"]));
exports["default"] = ImageRenderer;
